# Reworked Keras Optimizer

This directory is the hub for new Keras optimizers, as referenced by
`tf.keras.optimizers.XXX` and `tf.keras.optimizers.experimental.XXX`. Comparing
to optimizers in directory `optimizer_v2/`, these reworked optimizers improve on
the following part:

1.  Transparent logic. The new optimizer no longer relies on fused operations
    generated by c++ code, but writes algorithm in pure python code, and use
    XLA to ensure the performance.
2.  More friendly to customization. The new optimizer get rids of opaque logic
    such as `slot_variables`.
3.  Debugging friendly. The new optimizer explicitly layers distributed training
    code aside from the other part, and gets rid of TF1 code. When error is
    found, it will provide explicit action items.
